//---------------------------------------------------------------------------
//
// Name:        wxpicsimFrm.cpp
// Author:      gamboa
// Created:     16/9/2008 14:07:36
// Description: wxpicsimFrm class implementation
//
//---------------------------------------------------------------------------

#include "wxpicsimFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
#include "wxpicsimFrm_WxStaticBitmap1_XPM.xpm"
////Header Include End
#include"../picsim.h"
#include"../p16fxxx.h"

//----------------------------------------------------------------------------
// wxpicsimFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxpicsimFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxpicsimFrm::OnClose)
	EVT_TIMER(ID_WXTIMER1,wxpicsimFrm::WxTimer1Timer)
	EVT_BUTTON(ID_WXBUTTON1,wxpicsimFrm::WxButton1Click)
END_EVENT_TABLE()
////Event Table End

pic16f pic1; 
int picrun=0;

wxpicsimFrm::wxpicsimFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

wxpicsimFrm::~wxpicsimFrm()
{
}

void wxpicsimFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxPanel1 = new wxPanel(this, ID_WXPANEL1, wxPoint(0,0), wxSize(630,456));
	WxPanel1->SetBackgroundColour(wxColour(*wxWHITE));
	WxPanel1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	wxBitmap WxStaticBitmap1_BITMAP(wxpicsimFrm_WxStaticBitmap1_XPM);
	WxStaticBitmap1 = new wxStaticBitmap(WxPanel1, ID_WXSTATICBITMAP1, WxStaticBitmap1_BITMAP, wxPoint(107,73), wxSize(496,332));
	WxStaticBitmap1->Enable(true);
	WxStaticBitmap1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox1 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX1, wxT(""), wxPoint(250,121), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox1"));
	WxCheckBox1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox2 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX2, wxT(""), wxPoint(250,147), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox2"));
	WxCheckBox2->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox3 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX3, wxT(""), wxPoint(250,174), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox3"));
	WxCheckBox3->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox4 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX4, wxT(""), wxPoint(250,200), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox4"));
	WxCheckBox4->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox5 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX5, wxT(""), wxPoint(250,228), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox5"));
	WxCheckBox5->Enable(false);
	WxCheckBox5->SetValue(false);
	WxCheckBox5->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox6 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX6, wxT(""), wxPoint(250,260), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox6"));
	WxCheckBox6->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox7 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX7, wxT(""), wxPoint(250,286), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox7"));
	WxCheckBox7->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox8 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX8, wxT(""), wxPoint(250,316), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox8"));
	WxCheckBox8->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox9 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX9, wxT(""), wxPoint(250,346), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox9"));
	WxCheckBox9->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox10 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX10, wxT(""), wxPoint(404,346), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox10"));
	WxCheckBox10->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox11 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX11, wxT(""), wxPoint(404,316), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox11"));
	WxCheckBox11->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox12 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX12, wxT(""), wxPoint(404,291), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox12"));
	WxCheckBox12->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox13 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX13, wxT(""), wxPoint(404,261), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox13"));
	WxCheckBox13->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox14 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX14, wxT(""), wxPoint(404,232), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox14"));
	WxCheckBox14->Enable(false);
	WxCheckBox14->SetValue(true);
	WxCheckBox14->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox15 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX15, wxT(""), wxPoint(404,203), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox15"));
	WxCheckBox15->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox16 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX16, wxT(""), wxPoint(404,175), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox16"));
	WxCheckBox16->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox17 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX17, wxT(""), wxPoint(404,147), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox17"));
	WxCheckBox17->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox18 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX18, wxT(""), wxPoint(404,120), wxSize(18,17), 0, wxDefaultValidator, wxT("WxCheckBox18"));
	WxCheckBox18->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxButton1 = new wxButton(WxPanel1, ID_WXBUTTON1, wxT("Carregar"), wxPoint(99,20), wxSize(75,25), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxEdit1 = new wxTextCtrl(WxPanel1, ID_WXEDIT1, wxT("WxEdit1"), wxPoint(194,24), wxSize(282,19), 0, wxDefaultValidator, wxT("WxEdit1"));
	WxEdit1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxOpenFileDialog1 =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.hex"), wxOPEN);

	WxTimer1 = new wxTimer();
	WxTimer1->SetOwner(this, ID_WXTIMER1);
	WxTimer1->Start(100);

	SetTitle(wxT("wxpicsim"));
	SetIcon(wxNullIcon);
	SetSize(8,8,638,483);
	Center();
	
	////GUI Items Creation End
}

void wxpicsimFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * WxTimer1Timer
 */
void wxpicsimFrm::WxTimer1Timer(wxTimerEvent& event)
{
	// insert your code here
unsigned int i;

   if(picrun == 0)
   {
        WxEdit1->SetValue(wxT("Parado!"));
        return;
   }
   WxEdit1->SetValue(wxT("Rodando..."));     
   
    
   
   if (pic_get_pin_dir(&pic1,1) == PD_IN)
   {
       WxCheckBox1->Enable(true);
       pic_set_pin(&pic1,1,WxCheckBox1->GetValue());   
   }
   else
   {     
       WxCheckBox1->Enable(false);
       WxCheckBox1->SetValue(pic_get_pin(&pic1,1));
   }    
   
   if (pic_get_pin_dir(&pic1,2) == PD_IN)
   {
       WxCheckBox2->Enable(true);
       pic_set_pin(&pic1,2,WxCheckBox2->GetValue());   
   }
   else
   {
       WxCheckBox2->Enable(false);
       WxCheckBox2->SetValue(pic_get_pin(&pic1,2));
   }
   
   if (pic_get_pin_dir(&pic1,3) == PD_IN)
   {
       WxCheckBox3->Enable(true);
       pic_set_pin(&pic1,3,WxCheckBox3->GetValue());   
   }
   else
   {
       WxCheckBox3->Enable(false);
       WxCheckBox3->SetValue(pic_get_pin(&pic1,3));
   }
   
   if (pic_get_pin_dir(&pic1,4) == PD_IN)
   {
       WxCheckBox4->Enable(true);
       pic_set_pin(&pic1,4,WxCheckBox4->GetValue());   
   }
   else
   {
       WxCheckBox4->Enable(false);
       WxCheckBox4->SetValue(pic_get_pin(&pic1,4));
   }
   
    
   if (pic_get_pin_dir(&pic1,6) == PD_IN)
   {
       WxCheckBox6->Enable(true);
       pic_set_pin(&pic1,6,WxCheckBox6->GetValue());   
   }
   else
   {
       WxCheckBox6->Enable(false);
       WxCheckBox6->SetValue(pic_get_pin(&pic1,6));
   }
   
   if (pic_get_pin_dir(&pic1,7) == PD_IN)
   {
       WxCheckBox7->Enable(true);
       pic_set_pin(&pic1,7,WxCheckBox7->GetValue());   
   }
   else
   {
       WxCheckBox7->Enable(false);
       WxCheckBox7->SetValue(pic_get_pin(&pic1,7));
   }
   
   if (pic_get_pin_dir(&pic1,8) == PD_IN)
   {
       WxCheckBox8->Enable(true);
       pic_set_pin(&pic1,8,WxCheckBox8->GetValue());   
   }
   else
   {
       WxCheckBox8->Enable(false);
       WxCheckBox8->SetValue(pic_get_pin(&pic1,8));
   }      
  
   if (pic_get_pin_dir(&pic1,9) == PD_IN)
   {
       WxCheckBox9->Enable(true);
       pic_set_pin(&pic1,9,WxCheckBox9->GetValue());   
   }
   else
   {
       WxCheckBox9->Enable(false);
       WxCheckBox9->SetValue(pic_get_pin(&pic1,9));
   }
   
   if (pic_get_pin_dir(&pic1,10) == PD_IN)
   {
       WxCheckBox10->Enable(true);
       pic_set_pin(&pic1,10,WxCheckBox10->GetValue());   
   }
   else
   {
       WxCheckBox10->Enable(false);
       WxCheckBox10->SetValue(pic_get_pin(&pic1,10));
   }
   
   if (pic_get_pin_dir(&pic1,11) == PD_IN)
   {
       WxCheckBox11->Enable(true);
       pic_set_pin(&pic1,11,WxCheckBox11->GetValue());   
   }
   else
   {
       WxCheckBox11->Enable(false);
       WxCheckBox11->SetValue(pic_get_pin(&pic1,11));
   }
   
   if (pic_get_pin_dir(&pic1,12) == PD_IN)
   {
       WxCheckBox12->Enable(true);
       pic_set_pin(&pic1,12,WxCheckBox12->GetValue());   
   }
   else
   {
       WxCheckBox12->Enable(false);
       WxCheckBox12->SetValue(pic_get_pin(&pic1,12));
   }
   
   if (pic_get_pin_dir(&pic1,13) == PD_IN)
   {
       WxCheckBox13->Enable(true);
       pic_set_pin(&pic1,13,WxCheckBox13->GetValue());   
   }
   else
   {
       WxCheckBox13->Enable(false);
       WxCheckBox13->SetValue(pic_get_pin(&pic1,13));
   }
   
   if (pic_get_pin_dir(&pic1,15) == PD_IN)
   {
       WxCheckBox15->Enable(true);
       pic_set_pin(&pic1,15,WxCheckBox15->GetValue());   
   }
   else
   {
       WxCheckBox15->Enable(false);
       WxCheckBox15->SetValue(pic_get_pin(&pic1,15));
   }
   
   if (pic_get_pin_dir(&pic1,16) == PD_IN)
   {
       WxCheckBox16->Enable(true);
       pic_set_pin(&pic1,16,WxCheckBox16->GetValue());   
   }
   else
   {
       WxCheckBox16->Enable(false);
       WxCheckBox16->SetValue(pic_get_pin(&pic1,16));
   }
   
   if (pic_get_pin_dir(&pic1,17) == PD_IN)
   {
       WxCheckBox17->Enable(true);
       pic_set_pin(&pic1,17,WxCheckBox17->GetValue());   
   }
   else
   {
       WxCheckBox17->Enable(false);
       WxCheckBox17->SetValue(pic_get_pin(&pic1,17));
   }
   
   if (pic_get_pin_dir(&pic1,18) == PD_IN)
   {
       WxCheckBox18->Enable(true);
       pic_set_pin(&pic1,18,WxCheckBox18->GetValue());   
   }
   else
   {
       WxCheckBox18->Enable(false);
       WxCheckBox18->SetValue(pic_get_pin(&pic1,18));
   }
   
    
    for(i=0;i<100000;i++)
          pic_step(&pic1,0);
}

/*
 * WxButton1Click
 */
void wxpicsimFrm::WxButton1Click(wxCommandEvent& event)
{
	// insert your code here
      
   if(WxOpenFileDialog1->ShowModal() == wxID_OK)
   {   
        
       if(pic_init(&pic1,P16F628A,WxOpenFileDialog1->GetPath().fn_str(),1,4e6 ) == 1)
       {
        picrun=1;
       }
       else
       {
        picrun=0;    
       }
    }
    else
    {
      picrun=0;
     }
}
